Package: altcdfenvs
Version: 2.74.0
Title: alternative CDF environments (aka probeset mappings)
Author: Laurent Gautier <lgautier@gmail.com>
Maintainer: Laurent Gautier <lgautier@gmail.com>
biocViews: Microarray, OneChannel, QualityControl, Preprocessing,
        Annotation, ProprietaryPlatforms, Transcription
Depends: R (>= 2.7), methods, BiocGenerics (>= 0.1.0), S4Vectors (>=
        0.9.25), Biobase (>= 2.15.1), affy, makecdfenv, Biostrings,
        hypergraph
Suggests: plasmodiumanophelescdf, hgu95acdf, hgu133aprobe, hgu133a.db,
        hgu133acdf, Rgraphviz, RColorBrewer
Description: Convenience data structures and functions to handle
        cdfenvs
License: GPL (>= 2)
Collate: appendCdfEnvAffy.R buildCdfEnv.matchprobes.R
        buildCdfEnv.biostrings.R CdfEnv.R cdfenvs.R copyCdfEnvAffy.R
        readFASTA.R removeIndex.R unique.CdfEnvAffy.R
LazyLoad: yes
Packaged: 2026-04-28 20:34:29 UTC; biocbuild
git_url: https://git.bioconductor.org/packages/altcdfenvs
git_branch: RELEASE_3_23
git_last_commit: d1163ab
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no

##setGeneric("unique", function(x, incomparables, ...) standardGeneric("unique"))

unique.CdfEnvAffy <- function(x, incomparables=FALSE, simplify=TRUE, verbose=FALSE, ...) {
  counts <- countduplicated(x, incomparables=incomparables, verbose=verbose)
  tmp.env<- as(x, "environment")
  ids <- ls(tmp.env)
  ## copy env
  y <- new.env(hash=TRUE)
  if (verbose)
    cat("removing duplicated elements...")
  for (i in ids) {
    tmp.count <- get(i, envir=counts)
    tmp.i <- get(i, envir=tmp.env)
    tmp.ok <- tmp.count == 1
    tmp.i[!tmp.ok] <- NA
    tmp.new <- tmp.i[!apply(tmp.i, 1, function(x) all(is.na(x))), , drop=FALSE]
    if (length(tmp.new) == 0 && simplify) {
      ##if (verbose) {
      ##  cat(paste("removing ", i, " (does not have anymore elements).\n"))
      ##}
      next
    }
    assign(i, tmp.new, envir=y)
  }
  if (verbose)
    cat("done.\n")
  r <- x
  r@envir <- y
  r@envName <- paste(r@envName, "-unique", sep="")
  return(r)
}

##setMethod("unique", signature(x="CdfEnvAffy", incomparables="logical"), .unique.CdfEnvAffy)


countduplicated <- function(x, incomparables=FALSE, verbose=FALSE) {
  if (!is(x, "CdfEnvAffy"))
    stop("x must inherit from 'CdfEnvAffy'")

  if (incomparables != FALSE)
    warning("'incomparable' not yet implemented !")

  if (verbose)
    cat("Initialize...")

  tmp.env <- as(x, "environment")
  ids <- ls(tmp.env)
  p.type <- x@probeTypes

  tmp.count <- rep(as.integer(0),
                   length=sum(unlist(lapply(indexProbes(x, p.type), length))))
  r <- new.env(hash = TRUE)
  if(verbose)
    cat("done.\nCounting probes...")

  for (i in seq(along = ids)) {
    p.i <- get(ids[i], envir = tmp.env)
    tmp.count[p.i] <- tmp.count[p.i] + 1
  }
  if (verbose)
    cat("done.\nAssigning counts...")
  for (i in seq(along = ids)) {
    p.i <- get(ids[i], envir = tmp.env)
    p.i[] <- tmp.count[p.i]
    assign(ids[i], p.i, envir=r)
  }
  if (verbose)
    cat("done.\n")
  return(r)
}

##
## Set of (hopefully convenient) functions to extract
## sequences and headers from FASTA files
##
## Laurent 2003 - under LGPL license


print.FASTA <- function(x, ...) {
  cat("FASTA sequence:\n", ...)
  if (is.null(x$header)) {
    cat("  NULL\n")
  } else {
    cat(paste("  ", substr(x$header, 1, 60), "...\n"), ...)
    cat(paste("  ", substr(x$sequence, 1, 60), "...\n"), ...)
  }
}

write.FASTA <- function(x, file="data.fasta", append = FALSE) {
  cat(x$header, file = file, "\n", sep = "", append = append)
  cat(x$sequence, file = file, "\n", sep = "", append = TRUE)
}

skip.FASTA.entry <- function(con, skip, linebreaks=3000) {
  ## skip FASTA entries in a connection
  for (i in rep(1, skip))
    read.FASTA.entry(con, linebreaks=linebreaks)
}

read.n.FASTA.entries <- function(con, n, linebreaks=3000) {
  ## read n FASTA entries in a connection
  ## return a list of length n
  r.list <- vector("list", length=n)
  for (i in seq(along=r.list))
    r.list[[i]] <- read.FASTA.entry(con)
  return(r.list)
}

read.n.FASTA.headers <- function(con, n, linebreaks=3000) {
  ## read n FASTA headers (skipping the sequences) in a connection
  ## return a vector of mode "character" of length n
  headers <- vector("character", length=n)
  for (i in seq(along=headers))
    headers[i] <- read.FASTA.entry(con)$header
  return(headers)
}

read.n.FASTA.sequences <- function(con, n, linebreaks=3000) {
  ## read n FASTA sequences(skipping the headers) in a connection
  ## return a vector of mode character
  
  seqs <- vector("character", length=n)
  for (i in seq(along=seqs))
    seqs[i] <- read.FASTA.entry(con)$sequence
  return(seqs)
}

read.n.FASTA.entries.split <- function(con, n, linebreaks=3000) {
  ## read n FASTA entries in a connection
  ## return a list of two elements:
  ##   - a vector of headers
  ##   - a vector of sequences
  
  headers <- vector("character", length=n)
  seqs <- vector("character", length=n)
  for (i in seq(along=seqs)) {
    fs <- read.FASTA.entry(con)
    headers[i] <- fs$header
    seqs[i] <- fs$sequence
  }
  r <- list(headers=headers, sequences=seqs)
  return(r)
}

countskip.FASTA.entries <- function(con, linebreaks=3000) {
  ## skip and count the remaining FASTA entries in a connection
  ## (handy to count the entries in a FASTA file)
  ## return an integer
  i <- as.integer(0)
  fs <- read.FASTA.entry(con)
  while(!identical(fs$header, character(0)) && !identical(fs$sequence, NULL)) {
    i <- i+1
    fs <- read.FASTA.entry(con, linebreaks=linebreaks)
  }
  return(i)
}

read.FASTA.entry <- function(con, linebreaks=3000) {
  ## read the next FASTA entry in a connection
  ## (note: the parameters 'linebreaks' should be increased
  ## for very large sequences split in more than 'linebreaks' lines)
  ## return a list of two elements:
  ##  - header: the FASTA header
  ##  - sequence: the sequence
  getnext.FASTA.header <- function(con) {
    line <- readLines(con, n=1)
    
    while(length(line) > 0) {
      if (substr(line, 1, 1) ==  ">") {
        break
      }
      line <- readLines(con, n=1)
    }
    return(line)
  }
  
  bioseq <- vector("list", length=linebreaks)
  i <- as.integer(1)
  one.integer <- as.integer(1)
  
  header <- getnext.FASTA.header(con)
  
  line <- readLines(con, n=1)
  
  while(length(line) > 0) {
    
    if (substr(line, 1, 1) == ">") {
      pushBack(line, con)
      break
    } else {
      bioseq[[i]] <- line
    }
    i <- i + one.integer
    line <- readLines(con, n=1)
  }
  if (identical(header, character(0))) {
    header <- NULL
    bioseq <- NULL
  } else {
    bioseq <- paste(bioseq[1 : (i-1)], collapse="")
  }
  r <- list(header=header, sequence=bioseq)
  class(r) <- "FASTA"  
  return(r)
}

grep.FASTA.entry <- function(pattern, con, ...) {
  ## grep the first FASTA entry with a header matching the pattern 'pattern'
  ##
  fs <- read.FASTA.entry(con)
  i <- 0
  while (! identical(fs$header, NULL)) {
    i <- i + 1
    if (length(grep(pattern, fs$header, ...)) > 0)
      break
    fs <- read.FASTA.entry(con)
  }
  attr(fs, "i") <- i
  return(fs)
}

buildCdfEnv.matchprobes <- function(matches, ids, probes.pack,
                                    abatch=NULL,
                                    nrow.chip=NULL, ncol.chip=NULL,
                                    chiptype=NULL, mm=NA, simplify = TRUE,
                                    x.colname = "x", y.colname = "y",
                                    verbose = FALSE) {

  .Deprecated("buildCdfEnv.biostrings", package="altcdfenvs")
  
  if (! (is.list(matches) && length(matches) > 0)) #&& length(matches[[1]]) < 3)
    stop("arg 'matches' should be a list as returned by 'matchprobes'.")

  if (length(matches[[1]]) != length(ids))
    stop("'matches' and 'ids' must have the same length.")

  if (length(matches[[1]]) != length(unique(ids)))
    stop("Some elements in 'ids' are not unique. You probably do not want this.")
  
  if ( ! is.null(abatch)) {
    if (! is(abatch, "AffyBatch"))
      stop("abatch must be of class 'AffyBatch'.")
    nrow.chip <- abatch@nrow
    ncol.chip <- abatch@ncol
    chiptype <- abatch@cdfName
  }

  if (is.null(nrow.chip) || is.null(ncol.chip) || is.null(chiptype))
    stop("nrow.chip, ncol.chip or chiptype not defined.")

  do.call(library, list(probes.pack))
  probe.tab <- get(probes.pack, envir=as.environment(paste("package:", probes.pack, sep="")))

  cdfenv <- new.env(hash=TRUE)

  if (verbose) {
    cat("Processing the matches:\n")
    pbt <- new("ProgressBarText", length(matches$match), barsteps = as.integer(20))
    open(pbt)
  }
  for (i in seq(along=matches$match)) {
    if (verbose)
      update(pbt)

    xy <- getxy.probeseq(probeseq=probe.tab, i.row=matches$match[[i]],
                         x.colname = x.colname, y.colname = y.colname)
    if (nrow(xy) == 0 && simplify) {
      next
    }
    assign(ids[i],
           cbind(xy2indices(xy[, 1], xy[, 2], nc=nrow.chip), mm),
           envir=cdfenv)
  }
  if (verbose)
    close(pbt)

  cdfenv <- wrapCdfEnvAffy(cdfenv, nrow.chip, ncol.chip, chiptype)
  return(cdfenv)
}

index2xy.CdfEnvAffy <- function(object, i) {
  indices2xy(i, nc = object@nrow) - getOption("BioC")$affy$xy.offset
}
xy2index.CdfEnvAffy <- function(object, x, y) {
  o <- getOption("BioC")$affy$xy.offset
  xy2indices(x+o, y+o, nc = object@nrow)
}

setClass("CdfEnvAffy",
         representation(envir = "environment",
                        envName = "character",
                        index2xy = "function",
                        xy2index = "function",
                        nrow = "integer",
                        ncol = "integer",
                        probeTypes = "character",
                        chipType = "character"),
         prototype = list(index2xy = index2xy.CdfEnvAffy,
           xy2index = xy2index.CdfEnvAffy))


## ---
setAs("CdfEnvAffy", "environment", function(from) from@envir )

setAs("CdfEnvAffy", "Cdf",
      function(from) {
        m <- matrix(as.numeric(NA), from@nrow, from@ncol)
        l <- ls(from@envir)
        for (i in seq(along=l)) {
          tmp <- indexProbes(from, "pm", l[i])[[1]]
          m[tmp] <- i
          tmp <- indexProbes(from, "mm", l[i])[[1]]
          m[tmp] <- i
        }
        cdf <- new("Cdf", cdfName=from@chipType, name=m, name.levels=l)
        return(cdf)
      }
      )


geneNames.CdfEnvAffy <- function(object) {
  ls(as(object, "environment"))
}
setMethod("geneNames", "CdfEnvAffy", geneNames.CdfEnvAffy)

## ---
setMethod("[", signature(x="CdfEnvAffy", i="character",
                         j="missing", drop="missing"),
function(x, i, j, drop=FALSE) {
  if( !missing(j)) {
    stop("Improper subsetting. Only one vector of IDs should be given.\n")
  }
  
  if (is.matrix(i)) {
    if (! is.integer(i)) {
      stop("not implemented")
         ##stop("when a matrix, 'i' should be of mode 'integer'")
    }
    y <- x
    y@envName <- paste(x@envName, "-subsetXYcoords", sep="")
    y@envir <- new.env(hash=TRUE, parent = emptyenv())
    
    ## make a Cdf (faster lookup for XY or indexes).
    cdfenv <- get(x@envName)
    cdf <- as(cdfenv, "Cdf")
    idx <- xy2index(x, i)
    for (i in idx) {
      id <- cdf@names.level[cdf@names[i]]
      tmp <- indexProbes(y, y@probeTypes, id)
      ## implementation not complete
      ## pm or mm to be sorted
      ## and idx appended to tmp
      assign(id, tmp, envir=y@envir)
    }
    
  } else {
    if (! is.character(i)) {
      stop("when not a matrix, 'i' should be of mode 'character'")
    }
    y <- x
    y@envName <- paste(x@envName, "-subsetProbeSets", sep="")
    y@envir <- new.env(hash=TRUE, parent = emptyenv())
    

    for (id in i) {
      ##tmp <- indexProbes(x, x@probeTypes, id)
      tmp <- do.call(cbind, lapply(x@probeTypes, function(pt) indexProbes(x, pt, id)[[1]]))
      assign(id, tmp, envir=y@envir)
    }
  }
  return(y)
})



## ---
indexProbes.CdfEnvAffy <- function(object, which, probeSetNames=NULL) {

  probeTypes <- object@probeTypes

  ##FIXME: hack for compatibility with 'affy'
  if (identical(which, "both") || identical(which, c("pm", "mm", "both"))) {
    which <- probeTypes
    warning("The use of \"both\" in 'which' is deprecated.")
  }
  ##

  if ( ! all(which %in% probeTypes))
    stop(paste("'which' can only take values from:", paste(probeTypes, collapse=", ")))

  i.probes <- match(which, probeTypes)

  envir <- as(object, "environment")

  if(is.null(probeSetNames))
    probeSetNames <- ls(envir)

  ans <-  mget(probeSetNames, envir=envir, ifnotfound=list(NA))

  ## this kind of thing could be included in 'multiget' as
  ## an extra feature. A function could be specified to
  ## process what is 'multi'-get on the fly
  for (i in seq(along=ans)) {

    if ( is.na(ans[[i]][1]) )
      next

    ##as.vector cause it might be a matrix if all probe types
    tmp <- as.vector(ans[[i]][, i.probes])

    ans[[i]] <- tmp
  }

  return(ans)
}

setMethod("indexProbes", signature("CdfEnvAffy", which = "character"),
         indexProbes.CdfEnvAffy)

## ---
setGeneric("index2xy", def = function(object, ...) standardGeneric("index2xy"))
setMethod("index2xy", signature(object="CdfEnvAffy"),
         function(object, ...) object@index2xy(object, ...))

## ---
setGeneric("xy2index", def = function(object, ...) standardGeneric("xy2index"), useAsDefault = FALSE)
setMethod("xy2index", signature(object="CdfEnvAffy"),
          function(object, ...) object@xy2index(object, ...))

## ---

plot.CdfEnvAffy <- function(x, xlab = "", ylab = "", main = x@chipType, ...) {
  plot(0, 0, xlim = range(0, x@nrow), ylim = range(0, x@ncol), type="n", xlab = xlab, ylab = ylab, main = main, ...)
}

setMethod("plot", signature(x="CdfEnvAffy", y="missing"), plot.CdfEnvAffy)

## ---

setMethod("show", signature("CdfEnvAffy"),
          function(object) {
            cat("Instance of class CdfEnvAffy:\n")
            cat(" name     :", object@envName, "\n")
            cat(" chip-type:", object@chipType, "\n")
            cat(" size     :", object@nrow, "x", object@ncol, "\n")
            cat("", length(ls(as(object, "environment"))), "probe set(s) defined.\n")
          })

## ---

validCdfEnvAffy <- function(cdfenv, verbose=TRUE) {

  if (verbose)
    cat("Validating CdfEnvAffy:\n")
  envir <- as(cdfenv, "environment")
  keys <- ls(envir)

  ## probe types
  if (verbose)
    cat("  Checking probe types.\n")
  n <- length(cdfenv@probeTypes)
  tmp <- rep(FALSE, n)
  for (i in seq(along=keys)) {
    if (ncol(get(keys[i], envir = envir)) != n)
      tmp[i] <- TRUE
  }
  if (n > 0 && sum(tmp) != 0)
    valid <- FALSE
  else
    valid <- TRUE
  r.probeTypes <- list(valid=valid, invalid.ones=keys[which(tmp)])
  if (verbose)
    cat(sum(tmp), "invalid ones.\n")
  ## XY
  if (verbose)
    cat("  Checking XY coordinates.\n")
  tmp <- rep(FALSE, n)
  for (i in seq(along=keys)) {
    ip <- indexProbes(cdfenv, which = cdfenv@probeTypes, probeSetNames = keys[i])[[1]]
    xy <- index2xy(cdfenv, ip)
    if (any(xy[, 1] > cdfenv@nrow, na.rm = TRUE) || any(xy[, 2] > cdfenv@ncol, na.rm = TRUE))
      tmp[i] <- TRUE
  }
  if (n > 0 && sum(tmp) != 0)
    valid <- FALSE
  else
    valid <- TRUE
  r.xy <- list(valid=valid, invalid.ones=keys[which(tmp)])
  if (verbose)
    cat(sum(tmp), "invalid ones\n")
  
  r.details <- list(probeTypes=r.probeTypes, xy=r.xy)

  r <- all( unlist(lapply(r.details, function(x) x$valid)) )
  attr(r, "details") <- r.details
  return(r)
}

## ---

printValidCdfEnvAffy <- function(x) {
  printDetails <- function(y) {
    if (y$valid) {
      cat("  valid.\n")
      return()
    }
    n <- length(y$invalid.ones)
    if (n == 1)
      cat(paste(" ", n, "invalid probe set\n"))
    else
      cat(paste(" ", n, "invalid probe sets\n"))
    if (n <= 5)
      cat(paste(y$invalid.ones, collapse=" "), "\n")
    else
      cat(paste(paste(y$invalid.ones[1:5], collapse=" "), "...\n"))
  }

  r.details <- attr(x, "details")

  cat("Probe types:\n")
  printDetails(r.details$probeTypes)

  cat("XY coordinates:\n")
  printDetails(r.details$xy)

}

## ---

validAffyBatch <- function(abatch, cdfenv) {
  stopifnot(is(abatch, "AffyBatch"),
            is(cdfenv, "CdfEnvAffy"))

  if ( (abatch@nrow != cdfenv@nrow) || (abatch@ncol != cdfenv@ncol))
    valid <- FALSE
  else
    valid <- TRUE

  return(valid)
    #r.dim <- list(valid = valid)

  #return(r.dim)
}


## ---

# setMethod("initialize", "CdfEnvAffy",
#           function(.Object) {

#           })

mmProbes <- function(probes)
{  
  len_probe <- unique(nchar(probes$sequence))
  if (length(len_probe) > 1)
    stop(paste("Different length for probes",
               "(and the handling of that case is not implemented)."))
  if (len_probe != 25)
    stop(paste("The expected probe length is 25 bp, not ",
               len_probe, ".", sep=""))
  mmpos <- 13


  ## First write. Using DNAStringSet, short and elegant...
  ## but unfortunately unbearably slow
  ##  mmseq <-
  ##     lapply(as.list(probes$stringset),
  ##            function(x) {
  ##              replaceLetterAt(x, mmpos,
  ##                              as.character(complement(x[mmpos])))
  ##            })
  pmprobe <- substr(probes$sequence, mmpos, mmpos)
  mmprobe <- rep(as.character(NA), length=length(pmprobe))
  mmprobe[grep("[Aa]", pmprobe)] <- "T"
  mmprobe[grep("[Tt]", pmprobe)] <- "A"
  mmprobe[grep("[Gg]", pmprobe)] <- "C"
  mmprobe[grep("[Cc]", pmprobe)] <- "G"
  mmseq <- paste(substr(probes$sequence, 1, mmpos-1),
                 mmprobe,
                 substr(probes$sequence, mmpos+1, nchar(probes$sequence)),
                 sep = "")
                   
  return(mmseq)
}


setClass("AffyProbesMatch",
 representation(pm = "list", mm = "list",
                labels = "character", chip_type = "character",
                probes = "ANY"), # should be class "probetable" - S4 don't seem to cope with it
 validity = function(obj) {
   if (length(obj@pm) != length(obj@mm))
     return("mm and pm should have identical lengths")
   if (length(obj@pm) != length(obj@labels))
     return("labels and pm should have identical lengths")
   if (any(duplicated(obj@labels)))
     return("labels should be unique.")
   if (length(obj@chip_type) != 1)
     return("chip_type should be *one* chip type name")
   if (! all(unlist(lapply(obj@pm,
                           function(y) inherits(y, "integer"))))) {
     return("all pm should inherit from numeric")
   }
   if (! all(unlist(lapply(obj@mm,
                           function(y) inherits(y, "integer"))))) {
     return("all mm should inherit from numeric")
   }
   return(TRUE)
 })

setMethod("show",
          signature = c("AffyProbesMatch"),
          function(object) {
            cat("AffyProbesMatch:\n")
            cat(paste(length(object@pm),
                      "target(s) sequences matched",
                      "against", nrow(object@probes),
                      "probes of chip type", object@chip_type,
                      ".\n"))
          }
          )

setMethod("combine",
          signature = c("AffyProbesMatch", "AffyProbesMatch"),
          function(x, y, ...) {
            if (x@chip_type != y@chip_type)
              stop("Both 'chip_type' must be identical.")
            if (! identical(x@probes, y@probes))
              stop("Both probe tables must be identical.")
            pm <- c(x@pm, y@pm)
            mm <- c(x@mm, y@mm)
            labels <- c(x@labels, y@labels)
            chip_type <- x@chip_type
            probetable <- x@probes
            res <- new("AffyProbesMatch",
                       pm = pm, mm = mm,
                       labels = labels,
                       chip_type = chip_type,
                       probes = probetable)
            return(res)
          })

toHypergraph <-
  function(object, ...) {
    stop("Not available for the given signature.")
  }
setGeneric("toHypergraph")
setMethod("toHypergraph",
          signature = c("AffyProbesMatch"),
          function(object, simplify=TRUE, ...) {
            if (simplify) {
              target_match <-
                unlist(lapply(object@pm, function(x) length(x) > 0))
              probe_match <- rep(FALSE, length=nrow(object@probes))
               for (i in which(target_match)) {
                 probe_match[object@pm[[i]]] <- TRUE
               }
            } else {
              target_match <- rep(TRUE, length=length(object@pm))
              probe_match <- rep(TRUE, length=nrow(object@probes))
            }

            i_match <- rep(as.integer(NA), nrow(object@probes))
            i_match[probe_match] <- seq(along=which(probe_match))
            
            nodes <-
              paste(as.character(object@probes[["x"]][probe_match]),
                    as.character(object@probes[["y"]][probe_match]),
                    sep = "-")

            hEdges <- lapply(object@pm[target_match],
                             function(x) Hyperedge(nodes[i_match[x]]))
            names(hEdges) <- object@labels[target_match]
            
            hg <- new("Hypergraph",
                      nodes = nodes,
                      hyperedges = hEdges)
            return(hg)
          }
          )

setMethod("toHypergraph",
          signature = c("CdfEnvAffy"),
          function(object, ...)
          {
            targets <- ls(object@envir)
            nodesEnv <- new.env(hash=TRUE, parent=emptyenv())
            for (n in targets) {
              m <- object@envir[[n]]
              labels <- apply(index2xy(object, m[, 1]), 1,
                              function(x) paste(x, collapse="-"))   
              nodesEnv[[n]] <- labels
            }
            nodes <- unlist(as.list(nodesEnv), use.names=FALSE)
            nodes <- unique(nodes)
            hEdges <- lapply(nodesEnv,
                             function(x) Hyperedge(x))
            
            hg <- new("Hypergraph",
                      nodes = nodes,
                      hyperedges = hEdges)
            return(hg)
          })

matchAffyProbes <-
  function(probes, targets, chip_type,
           matchmm = TRUE,
           selectMatches = function(x) which(elementNROWS(x) > 0),
           ...)
{

  if (! inherits(probes, "probetable")) {
    stop(paste("'probes' should inherit from class 'probetable'."))
  }

  stringset <- DNAStringSet(probes$sequence)
  
  if (inherits(targets, "character")) {
    targets <- as.list(targets)
    for (ii in seq(along = targets)) {
      if (is.na(targets[[ii]])) {
        stop(paste("Target", ii, "is NA."))
      }
      targets[[ii]] <- DNAString(targets[[ii]])
    }
  } else if (inherits(targets, "list")) {
    for (ii in seq(along = targets)) {
      if (! inherits(targets[[ii]], "DNAString")) {
        stop("Invalid 'targets'.")
      }
    }
  } else if (! inherits(targets, "DNAString")) {
    stop("Invalid 'targets'.")
  }
  
  labels <- names(targets)
  if (is.null(labels)) {
    labels <- as.character(seq(along=targets))
  }
  
  pmdict <- PDict(stringset)
  mindex_pm <- vector("list", length = length(targets))
  for (ii in seq(along = targets)) {
    md <- matchPDict(pmdict, targets[[ii]], ...)
    mindex_pm[[ii]] <- selectMatches(md)
  }

  mindex_mm <- vector("list", length = length(targets))
  if (matchmm) {
    mmseq <- mmProbes(probes)
    mmdict <- PDict(mmseq)
    for (ii in seq(along = targets)) {
      md <- matchPDict(mmdict, targets[[ii]], ...)
      mindex_mm[[ii]] <- selectMatches(md)
    }
  }
  
  apm <- new("AffyProbesMatch", pm = mindex_pm, mm = mindex_mm,
             labels = labels, chip_type = chip_type, probes=probes)
  return(apm)  
}




buildCdfEnv.biostrings <- function(apm,
                                   abatch=NULL,
                                   nrow.chip=NULL, ncol.chip=NULL,
                                   simplify = TRUE,
                                   x.colname = "x", y.colname = "y",
                                   verbose = FALSE)
{

  if (verbose)
    cat("validating 'apm'...")
  validObject(apm)
  if (verbose)
    cat("done.\n")
  
  if ( ! is.null(abatch)) {
    if (! is(abatch, "AffyBatch"))
      stop("abatch must be of class 'AffyBatch'.")
    nrow.chip <- abatch@nrow
    ncol.chip <- abatch@ncol
    chip_type <- abatch@cdfName
  }

  if (is.null(nrow.chip) || is.null(ncol.chip))
    stop("nrow.chip, ncol.chip")

  probetab <- apm@probes
  
  cdfenv <- new.env(hash=TRUE)

  if (verbose) {
    cat("Processing the matches:\n")
    pbt <- new("ProgressBarText", length(apm@pm),
               barsteps = as.integer(20))
    open(pbt)
  }

  ##FIXME:
  warning("Check index for MM probes.")
  for (i in seq(along = apm@pm)) {
    if (verbose)
      update(pbt)

    xy <- getxy.probeseq(probeseq = probetab,
                         i.row = apm@pm[[i]],
                         x.colname = x.colname, y.colname = y.colname)
    if (nrow(xy) == 0 && simplify) {
      next
    }
    assign(apm@labels[i],
           cbind(xy2indices(xy[, 1], xy[, 2], nc=nrow.chip),
                 xy2indices(xy[, 1]+1, xy[, 2], nc=nrow.chip)),
           envir=cdfenv)
  }
  if (verbose)
    close(pbt)

  cdfenv <- wrapCdfEnvAffy(cdfenv, nrow.chip, ncol.chip, apm@chip_type)
  return(cdfenv)
}

wrapCdfEnvAffy <- function(cdfenv, nrow.chip, ncol.chip, chiptype, check = TRUE, verbose = FALSE) {
  object <- new("CdfEnvAffy", envir = cdfenv,
                envName = chiptype,
                nrow = as.integer(nrow.chip), ncol = as.integer(ncol.chip),
                probeTypes = c("pm", "mm"),
                chipType = chiptype)
  if (check) {
    valid <- validCdfEnvAffy(object, verbose=verbose)
    if ( ! valid ) {
      printValidCdfEnvAffy(valid)
      stop("invalid CdfEnvAffy")
    }
  }
  return(object)
}

getCdfEnvAffy <- function(abatch) {
  if (! is(abatch, "AffyBatch"))
    stop("arg must be of class 'AffyBatch'.")

  cdfenv <- getCdfInfo(abatch)

  cdfenv <- wrapCdfEnvAffy(cdfenv, abatch@nrow, abatch@ncol, abatch@cdfName)
  return(cdfenv)
}


getxy.probeseq <- function(ppset.id=NULL, probeseq=NULL, i.row=NULL,
                           xy.offset=NULL,
                           x.colname = "x", y.colname = "y") {

  if ( is.null(xy.offset) ) {
    xy.offset <- getOption("BioC")$affy$xy.offset
  }
  
  if (sum(c(is.null(ppset.id), is.null(i.row))) != 1)
    stop("specify one and only one of 'ppset.id', 'i.row'")

  if (is.null(probeseq))
    stop("the argument 'probeseq' must be specified !")
  
  if (is.null(i.row))
    i.row <- probeseq$Probe.Set.Name %in% ppset.id

    
  mm.offset <- rep(0, length=length(i.row))
  mm.offset[i.row < 0] <- 1
  i.row <- abs(i.row)

  xy <- cbind(probeseq[[x.colname]][i.row],
              probeseq[[y.colname]][i.row] + mm.offset) + xy.offset
  
  colnames(xy) <- c("x", "y")
  return(xy)
}

removeIndex <- function(x, i, simplify = TRUE, verbose=FALSE) {
  if (! is.integer(i)) {
    stop("'i' must be of mode integer.")
  }
  remove.me <- rep(FALSE, length=max(i))
  remove.me[i] <- TRUE
  tmp.env<- as(x, "environment")
  ids <- ls(tmp.env)
  ## copy env
  y <- new.env(hash=TRUE)
  if (verbose)
    cat("removing duplicated elements...")
  for (i in ids) {
    tmp.i <- get(i, envir=tmp.env)
    tmp.ok <- (c(tmp.i) > length(remove.me)) | (! remove.me[c(tmp.i)])
    tmp.i[!tmp.ok] <- NA
    tmp.new <- tmp.i[!apply(tmp.i, 1, function(x) all(is.na(x))), , drop=FALSE]
    if (length(tmp.new) == 0 && simplify) {
      ##if (verbose) {
      ##  cat(paste("removing ", i, " (does not have anymore elements).\n"))
      ##}
      next
    }
    assign(i, tmp.new, envir=y)
  }
  if (verbose)
    cat("done.\n")
  r <- x
  r@envir <- y
  r@envName <- paste(r@envName, "-removed", sep="")
  return(r)
}

library(RUnit)

library(altcdfenvs)

pm_1 <- "AATAATAATAATAATAATAATAAGC"
mm_1 <- "AATAATAATAATTATAATAATAAGC"

pm_2 <- "CCACCACCACCACCACCACCACCTG"
mm_2 <- "CCACCACCACCAGCACCACCACCTG"

pm_3 <- "GGAGGGAGGGAGGGAGGGAGGGACT"
mm_3 <- "GGAGGGAGGGAGCGAGGGAGGGACT"

pm_4 <- "TTATTATTATTATTATTATTATTGC"
mm_4 <- "TTATTATTATTAATATTATTATTGC"


probetable <-
  data.frame(sequence = I(c(pm_1, pm_2, pm_3, pm_4)),
             x = c(10, 11, 13, 13),
             y = c(10, 12, 11, 12),
             Probe.Set.Name = I(c("12_at", "12_at", "m4_at", "4_at")),
             Probe.interrogation.Position = c(100, 120, 130, 140),
             Target.Strandeness = factor(rep("Antisense", 4)))

class(probetable) <- c("data.frame", "probetable")

## test mmProbe
mmp <- mmProbes(probetable)
checkIdentical(c(mm_1, mm_2, mm_3, mm_4), mmp)



target_1 <- paste(pm_1, pm_2, sep="GCGCG")
target_2 <- paste(pm_1, pm_4, sep="GCGCG")
target_3 <- paste("GGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGG", mm_3, sep="")

targets <- list(t1 = DNAString(target_1),
                t2 = DNAString(target_2),
                t3 = DNAString(target_3))

## test match
apm <- matchAffyProbes(probetable, targets,
                       chip_type = "foo")


checkIdentical(apm@pm[[1]], as.integer(c(1,2)))
checkIdentical(apm@pm[[2]], as.integer(c(1,4)))
checkIdentical(apm@pm[[3]], integer(0))

checkIdentical(apm@mm[[2]], integer(0))
checkIdentical(apm@mm[[3]], as.integer(c(3)))


## test merge

checkIdentical(combine(matchAffyProbes(probetable, targets[1:2], "foo"),
                       matchAffyProbes(probetable, targets[3], "foo")),
               matchAffyProbes(probetable, targets, "foo"))



## toHypergraph

hg <- toHypergraph(apm)


## test build env

altCdf <- buildCdfEnv.biostrings(apm, nrow.chip = 15, ncol.chip = 15)

##

checkIdentical(hg, toHypergraph(altCdf))


altenv <- as(altCdf, "environment")


#

cdfenv <- new.env(hash = TRUE, parent=emptyenv())

appendCdfEnvAffy <- function(acdfenv, id, i, nocopy=TRUE) {

  stopifnot(is.character(id), is.matrix(i), is.integer(i))
  tmp.m <- match(colnames(i), acdfenv@probeTypes)

  if (! all(colnames(i) %in% acdfenv@probeTypes)) {
    stop("the CdfEnv only knows about probe types:\n", paste(acdfenv@probeTypes, collapse=","))
  }

  if (exists(id, envir=acdfenv@envir)) {
    stop("'id' already in 'adfenv'")
  }

  if (! nocopy) {
    acdfenv <- copyCdfEnvAffy(acdfenv)
  }

  m <- matrix(as.integer(NA), nrow=nrow(i), ncol=length(acdfenv@probeTypes))
  m[, tmp.m] <- i
  
  ##DEBUG: a consistency check (i.e., the index make sense given the
  ##       geometry of the chip) would be nice...

  assign(id, m, envir=acdfenv@envir)

  return(acdfenv)
    
}

% -*- mode: noweb; noweb-default-code-mode: R-mode; -*-
%\VignetteIndexEntry{Alternative CDF environments for 2(or more)-genomes chips}
%\VignetteKeywords{Preprocessing, Affymetrix}
%\VignetteDepends{altcdfenvs}
%\VignettePackage{altcdfenvs}
%documentclass[12pt, a4paper]{article}
\documentclass[12pt]{article}

\usepackage{amsmath}
\usepackage{hyperref}
\usepackage[authoryear,round]{natbib}

\textwidth=6.2in
\textheight=8.5in
%\parskip=.3cm
\oddsidemargin=.1in
\evensidemargin=.1in
\headheight=-.3in

\newcommand{\scscst}{\scriptscriptstyle}
\newcommand{\scst}{\scriptstyle}
\newcommand{\Rfunction}[1]{{\texttt{#1}}}
\newcommand{\Robject}[1]{{\texttt{#1}}}
\newcommand{\Rclass}[1]{{\texttt{#1}}}
\newcommand{\Rpackage}[1]{{\textit{#1}}}

\author{Laurent Gautier}
\title{Alternative CDF environments for 2(or more)-genomes chips}

\begin{document}
\maketitle

\section*{Introduction}
Let's start by loading the package:
<<>>=
library(altcdfenvs)
@ 
The {\it Plasmodium} / {\it Anopheles} is taken as an example:
<<>>=
library(plasmodiumanophelescdf)
@
One will adapt easily the code below for other chips.

\section*{How to build a CdfEnvAffy object from the cdfenv package}
The first step is to wrap the naked enviroment in the package
\Rpackage{plasmodiumanophelescdf} in an object:
<<>>=
planocdf <- wrapCdfEnvAffy(plasmodiumanophelescdf, 712, 712, "plasmodiumanophelescdf")
print(planocdf)
@ 
The numbers $712$ and $712$ correspond to the dimension of the array.
If you do not know these numbers for your chip, the easiest (for the
moment) is to read CEL data in an \Rclass{AffyBatch} and call the function
\Rfunction{print} on this object.

\section*{How to create a CdfEnvAffy that is a subset of the 2-genomes one}

If the identifiers starting with `Pf' correspond to plasmodium, it is an easy job
to find them:
<<>>=
ids <- geneNames(planocdf)
ids.pf <- ids[grep("^Pf", ids)]
@ 

Subsetting the \Rclass{CdfEnvAffy} is also an easy task:
<<>>=
## subset the object to only keep probe sets of interest
plcdf <- planocdf[ids.pf]
print(plcdf)
@

However, this is not that simple:{\bf the environment created does not contain all the probe
set ids from Plasmodium}. Unfortunately, one cannot rely on pattern matching on the probe set
id to find all the probe set ids associated with Plasmodium. 
The list of plasmodium ids included in the package can let us build a Plasmodium-only
CdfEnvAffy (contributed by Zhining Wang).
<<>>=
filename <- system.file("exampleData", "Plasmodium-Probeset-IDs.txt",
                             package="altcdfenvs")
ids.pf <- scan(file = filename, what = "")
plcdf <- planocdf[ids.pf]
print(plcdf)
@ 

Before we eventually save our environment, we may want to give it an explicit name:
<<>>=
plcdf@envName <- "Plasmodium ids only"
print(plcdf)
@ 
\section*{Assign the new Cdf data to an AffyBatch}
Handling of AffyCdfEnv directly in within an AffyBatch, or AffyBatch-like,
structure is being completed\ldots in the meanwhile, the current mecanism
for cdfenvs has to be used.

If your CEL files were read into an AffyBatch named \Robject{abatch}.

\begin{Scode}
envplcdf <- as(plcdf, "environment")
abatch@cdfName <- "plcdf"
\end{Scode}

From now on, \Robject{abatch} will only consider Cdf information from \Robject{plcdf}.
If you want to save this further use, I would recommend to do:

\begin{Scode}
save(abatch, plcdf, envplcdf, file="where/to/save.rda")
\end{Scode}

\end{document}

% -*- mode: noweb; noweb-default-code-mode: R-mode; -*-
%\VignetteIndexEntry{altcdfenvs}
%\VignetteKeywords{Preprocessing, Affymetrix}
%\VignetteDepends{altcdfenvs}
%\VignettePackage{altcdfenvs}
\documentclass[12pt]{article}

%\usepackage{amsmath}
%\usepackage{hyperref}
\usepackage[authoryear,round]{natbib}

\textwidth=6.2in
\textheight=8.5in
%\parskip=.3cm
\oddsidemargin=.1in
\evensidemargin=.1in
\headheight=-.3in

\newcommand{\scscst}{\scriptscriptstyle}
\newcommand{\scst}{\scriptstyle}
\newcommand{\Rfunction}[1]{{\texttt{#1}}}
\newcommand{\Robject}[1]{{\texttt{#1}}}
\newcommand{\Rclass}[1]{{\texttt{#1}}}
\newcommand{\Rpackage}[1]{{\textit{#1}}}

\author{Laurent Gautier}
\title{Alternative CDF environments}

\begin{document}
\maketitle

\tableofcontents

\section{Introduction}
On short oligonuleotide arrays, several probes are designed to match
a target transcript, and probes matching the same target transcript
can be grouped in a probe set. Between the time the probes for a given short
oligonucleotide chip were designed, and the time an analysis is made,
the knowledge of expected transcripts for a given organism might have changed.
Unless one includes the latest development in transcripts into
an analysis, the analysis could suffer from what we like to call a
{\it Dorian Gray}\footnote{From the novel `The Picture of
  Dorian Gray' by Oscar Wilde.} effect. The chip itself does not change,
 which means
that the probes and their respective sequences remain the same, while
the knowledge of the transcripts, and eventually their sequence, might
evolve, and in time the immobility of the probe and probe sets give an
uglier picture of the biological phenomena to study. Being able to
easily modify or replace the grouping of probes in probe sets gives
the opportunity to minimize this effect.

The package is directly usable with {\it Affymetrix} {\it GeneChip} short
oligonucleotide arrays, and can be adapted or extended to other platforms.


The bibliographic reference associated with the package is given by the command:
\begin{Scode}
citation(package="altcdfenvs")
\end{Scode}

\begin{quote}
 Alternative mapping of probes to genes for Affymetrix chips Laurent
  Gautier, Morten Mooller, Lennart Friis-Hansen, Steen Knudsen BMC
  Bioinformatics 2004, 5:111
\end{quote}

If you use it, consider citing it, and
if you cite it consider citing as well other packages it depends on. 

To start we will first load the package:
<<>>=
library(altcdfenvs)
@ 

\section{The class \Rclass{CdfEnvAffy}}
Each instance of this class contains a way to group probes in probe sets.
Different instances, describing different ways to group probes in
probe sets, can co-exist for a given chip type.

When experimenting, it is highly recommended to use the functions 
\Rfunction{validCdfEnvAffy}
and \Rfunction{validAffyBatch} to make sure that a given instance 
is a valid one. 

\section{Reading sequence information in FASTA connections}
The package contains simple functions to read {\bf R} connections in the FASTA
format. Typically, collections of sequences are stored in FASTA files,
which can be significantly large, one can wish to read and process 
sequences one after the other. This can
be done by opening the file in `r' mode:
<<>>=
fasta.filename <- system.file("exampleData", "sample.fasta",
                              package="altcdfenvs")
con <- file(fasta.filename, open="r")
@

Reading the sequences one after another, and printing information
about them in turn goes like:
<<>>=
fasta.seq <- read.FASTA.entry(con)
while(! is.null(fasta.seq$header)) {
  print(fasta.seq)
  fasta.seq <- read.FASTA.entry(con)
}
close(con)
@

One can foresee that the matching of a set of reference sequences against
all the probes can be parallelized easily: the reference sequences can
simply be distributed across different processors/machines. When
working with all the reference sequences in a single large FASTA file,
the option \Robject{skip} can let one implement a poor man's parallel 
sequence matching
very easily.

\section{Creating an alternative mapping from sequences in a FASTA file}


\subsection{Select the constituting elements}


\begin{itemize}
\item Chip type:
For this tutorial we decide to work with the Affymetrix chip HG-U133A.
\item Target sequences:
The set of target sequences we use for this tutorial is in the exemplar FASTA file:
<<>>=
## first, count the number of FASTA entries in our file
con <- file(fasta.filename, open="r")
n <- countskip.FASTA.entries(con)
close(con)

## read all the entries
con <- file(fasta.filename, open="r")
my.entries <- read.n.FASTA.entries.split(con, n)
close(con)
@ 

\end{itemize}





\subsection*{matching the probes}
The package \Rpackage{Biostrings} and the probe data package for
HG-U133A are required to perform the matching. The first step is
to load them:
<<>>=
library(hgu133aprobe)

@ 

The matching is done simply (one can refer to the documentation for the
package \Rpackage{Biostrings} for further details):
<<>>=

targets <- my.entries$sequences
names(targets) <-  sub(">.+\\|(Hs\\#|NM_)([^[:blank:]\\|]+).+", 
                       "\\1\\2", my.entries$headers)

m <- matchAffyProbes(hgu133aprobe, targets, "HG-U133A")


@ 


\subsection{analyzing the matches}

When the position of the match between probes and target sequences
does not matter, the association can be represented as a bipartite graph.

The method \Rfunction{toHypergraph} will transform an instance of
\Rclass{AffyProbesMatch} into an \Rclass{Hypergraph}.
<<>>=
hg <- toHypergraph(m)
@ 

Currently, there are not many functions implemented around hypergraphs,
so we convert it to a more common graph.

<<>>=
gn <- toGraphNEL(hg)
@ 

Since this is now a regular graph, all of probes and targets are regular
nodes on that graph. Node name-based rules can be applied to identify
whether a node is a target sequence or a probe.

<<>>=
targetNodes <- new.env(hash=TRUE, parent=emptyenv())
for (i in seq(along=targets)) {
  targetNodes[[names(targets)[i]]] <- i
}
@ 


Since the graph is relatively small, we can plot it, and see that
one probe is common to both probe sets:
<<label=plotGraph, fig = TRUE>>=
library(Rgraphviz)
tShapes <- rep("ellipse", length=length(targets))
names(tShapes) <- names(targets)
tColors <- rep("ivory", length=length(targets))
names(tColors) <- names(targets)

nAttrs <- list(shape = tShapes, fillcolor = tColors)
gAttrs <- list(node = list(shape = "rectangle", fixedsize = FALSE))

plot(gn, "neato",
     nodeAttrs = nAttrs,
     attrs = gAttrs)

@ 

Whenever a large number  oftarget sequences are involved, counting the degrees
will be more efficient than plotting.




The package contains a function to create a \Rclass{CdfEnv} from the matches:
<<label=buildCdfEnv>>=
alt.cdf <- 
  buildCdfEnv.biostrings(m, nrow.chip = 712, ncol.chip = 712)

@ 
Note that the size for chip must be
specified. This is currently a problem with cdfenvs as they are
created by the package \Rpackage{makecdfenv}. The class
\Rclass{CdfEnv} suggests a way to solve this (hopefully this will be
integrated in \Rpackage{makecdfenv} in the near future).
When this happens, the section below will be replaced by something
more intuitive. But in the meanwhile, here is the current way to use
our shiny brand new class \Rclass{CdfEnv}:

\begin{Scode}
## say we have an AffyBatch of HG-U133A chips called 'abatch'

## summary checks to avoid silly mistakes
validAffyBatch(abatch, alt.cdf)

## it is ok, so we proceed...

## get the environment out of it class
alt.cdfenv <- alt.cdf@envir

abatch@cdfName <- "alt.cdfenv"
\end{Scode}

From now on, the object \Robject{abatch} will use our `alternative
mapping' rather than the one provided by the manufacturer of the chip:

\begin{Scode}
print(abatch)
\end{Scode}

%\section*{Creating an alternative environment to store only perfect matches}

\section{Always up-to-date}

Even if alternative mapping is not used upstream of the analysis,
it can still be interesting to verify probesets highlighted during
data analysis. 

The \Rpackage{biomaRt} package makes withdrawing up-to-date sequences
very easy, and those sequences can be matched against the probes.

First, we create a \emph{mart}:
\begin{Scode}
library(biomaRt)
mart <- useMart("ensembl",dataset="hsapiens_gene_ensembl")
\end{Scode}
(refer to the documentation for the \Rpackage{biomaRt} for
further information).

\subsection{Casual checking of genes}

In this example, we assume that for one reason or an other
a researcher would like to know more about the probes matching
the SLAMF genes.

<<label=geneSymbolsSLAMF>>=
geneSymbols <- c("SLAMF1", "SLAMF3", "SLAMF6", "SLAMF7", "SLAMF8", "SLAMF9")
@ 
The vector \Robject{geneSymbols} defined can easily be replaced
by your favorite genes; the example below should still work.


We then write a convenience function 
\Robject{getSeq} to extract the sequences.
This function appenda a \verb+-<number>+ to
the HUGO symbol (as there might be several sequences
matching).
<<label=getSeq>>=
getSeq <- function(name) {
  seq <- getSequence(id=name, type="hgnc_symbol", 
                     seqType="cdna", mart = mart)

  targets <- seq$cdna
  if (is.null(targets))
    return(character(0))
  names(targets) <- paste(seq$hgnc_symbol, 1:nrow(seq), sep="-")
  return(targets)
}
@ 

% load saved data (instead of connecting to the mart)
<<label=loadTargetsSLAMF, echo=FALSE>>=
load(system.file("exampleData", "slamf_targets.RData",
                  package="altcdfenvs"))
@

The function let us obtain the target sequences very easily:
\begin{Scode}
targets <- unlist(lapply(geneSymbols,
                         getSeq))

\end{Scode}

The targets are matched as seen previously:
<<>>=
m <- matchAffyProbes(hgu133aprobe, targets, "HG-U133A")
@ 


A colorful graph can be made in order to visualize
how matching probes are distributed:
<<label=SLAMF, fig=TRUE>>=

hg <- toHypergraph(m)


gn <- toGraphNEL(hg)

library(RColorBrewer)
col <- brewer.pal(length(geneSymbols)+1, "Set1")
tColors <- rep(col[length(col)], length=numNodes(gn))
names(tColors) <- nodes(gn)
for (col_i in 1:(length(col)-1)) {
  node_i <- grep(paste("^", geneSymbols[col_i], 
                       "-", sep=""),
                       names(tColors)) 
  tColors[node_i] <- col[col_i]
}


nAttrs <- list(fillcolor = tColors)

plot(gn, "twopi", nodeAttrs=nAttrs)
@ 

\begin{itemize}
 \item Watch for \emph{SLAMF6} and \emph{SLAMF7}
 \item The second sequence in SLAMF8 can potentially has specific probes
(the rest of the probes are matching both SLAMF8 sequences)
\end{itemize}


Comparison with the official mapping can be made (not so simply,
a future version should address this)
<<>>=
library("hgu133a.db")
affyTab <- toTable(hgu133aSYMBOL)
slamf_i <- grep("^SLAMF", affyTab$symbol)
pset_id <- affyTab$probe_id[slamf_i]

library("hgu133acdf")
countProbes <- lapply(pset_id, function(x) nrow(hgu133acdf[[x]]))
names(countProbes) <- affyTab$symbol[slamf_i]
countProbes
@ 
The results do not appear in complete agreement with the matching just
performed.

\end{document}

% -*- mode: noweb; noweb-default-code-mode: R-mode; -*-
%\VignetteIndexEntry{Modifying existing CDF environments to make alternative CDF environments}
%\VignetteKeywords{Preprocessing, Affymetrix}
%\VignetteDepends{altcdfenvs}
%\VignettePackage{altcdfenvs}
%documentclass[12pt, a4paper]{article}
\documentclass[12pt]{article}

\usepackage{amsmath}
\usepackage{hyperref}
\usepackage[authoryear,round]{natbib}

\textwidth=6.2in
\textheight=8.5in
%\parskip=.3cm
\oddsidemargin=.1in
\evensidemargin=.1in
\headheight=-.3in

\newcommand{\scscst}{\scriptscriptstyle}
\newcommand{\scst}{\scriptstyle}
\newcommand{\Rfunction}[1]{{\texttt{#1}}}
\newcommand{\Robject}[1]{{\texttt{#1}}}
\newcommand{\Rclass}[1]{{\texttt{#1}}}
\newcommand{\Rpackage}[1]{{\textit{#1}}}

\author{Laurent Gautier}
\title{Modifying existing CDF environments to make alternative CDF environments}

\begin{document}
\maketitle

\section*{Introduction}
First we need to load the package:
<<>>=
library(altcdfenvs)
@ 
The {\it Plasmodium} / {\it Anopheles} is taken as an example:
<<>>=
library(plasmodiumanophelescdf)
@
One will adapt easily the code below for other chips.

\section*{How to build a CdfEnvAffy object from the cdfenv package}
The first step is to wrap the naked enviroment in the package
\Rpackage{plasmodiumanophelescdf} in an object:
<<>>=
planocdf <- wrapCdfEnvAffy(plasmodiumanophelescdf, 712, 712, "plasmodiumanophelescdf")
print(planocdf)
@ 
The numbers $712$ and $712$ correspond to the dimension of the array.
If you do not know these numbers for your chip, the easiest (for the
moment) is to read CEL data in an \Rclass{AffyBatch} and call the function
\Rfunction{print} on this object.
Hopefully, the cdf packages offered on the bioconductor website will be modified,
which will make this step (and the complication to know the dimension
of the chip) unncessary.

\section*{How to subset an environment using probe set ids}

(see the vignette `n-genomes chips')

\section*{How to work with given index / XY coordinates}

\subsection*{Getting index}

The method \Rfunction{indexProbes} is implemeted for objects of class \Rclass{AltCdfEnvs}
<<>>=
#indexProbes(planocdf, "pm", "")
@ 

One can directly work on the CDF data, without having to load CEL data.

\subsection*{Removing probe sets}

The function \Rfunction{removeIndex} let one remove probe sets given
their index.

\subsection*{Multiple use of index}

When crafting an AltCdfEnv, it can happen that probe indexes are used
by several probe sets.

The \Rfunction{unique.CdfEnvAffy} is designed to help one to deal with the issue.


\section*{How to use this environment}

(see the vignette `n-genomes chips')

\end{document}

\name{plot.CdfEnvAffy}
\alias{plot.CdfEnvAffy}
\title{ A function to `plot' a CdfEnvAffy }
\description{
  A function to set the axis and plot the outline for a CdfEnvAffy
}
\usage{
\method{plot}{CdfEnvAffy}(x, xlab = "", ylab = "", main = x@chipType, ...)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{x}{ a \code{CdfEnvAffy} }
  \item{xlab}{ label for the rows }
  \item{ylab}{ label for the columns }
  \item{main}{ label for the plot. The chip-type by default. }
  \item{\dots}{ optional parameters to be passed to the underlying
    function \code{plot}}
}
\details{
  This function does not `plot' much, but sets the coordinates for
  further plotting (see the examples).
}
\author{ Laurent }
\seealso{\code{\link{CdfEnvAffy-class}} }
\examples{
## See "CdfEnvAffy-class"
}
\keyword{ hplot }

\name{read.FASTA.entry}
\alias{read.FASTA.entry}
\alias{print.FASTA}
\alias{write.FASTA}
\alias{skip.FASTA.entry}
\alias{read.n.FASTA.entries}
\alias{read.n.FASTA.headers}
\alias{read.n.FASTA.sequences}
\alias{read.n.FASTA.entries.split}
\alias{countskip.FASTA.entries}
\alias{read.FASTA.entry}
\alias{grep.FASTA.entry}
\title{Functions to work with FASTA files / connections}
\description{
  Set of function to work with biological sequences stored in FASTA format.
}
\usage{
countskip.FASTA.entries(con, linebreaks = 3000)
grep.FASTA.entry(pattern, con, ...)
\method{print}{FASTA}(x, ...)
read.FASTA.entry(con, linebreaks = 3000)
read.n.FASTA.entries(con, n, linebreaks = 3000)
read.n.FASTA.entries.split(con, n, linebreaks = 3000)
read.n.FASTA.headers(con, n, linebreaks = 3000)
read.n.FASTA.sequences(con, n, linebreaks = 3000)
skip.FASTA.entry(con, skip, linebreaks = 3000)
write.FASTA(x, file="data.fasta", append = FALSE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{append}{append to the file (or not)}
  \item{con}{a \link{connection}}
  \item{file}{a file name}
  \item{linebreaks}{(to optimize the parsing, probably safe to leave it
    as it is)}
  \item{n}{number of entries to read}
  \item{pattern}{a pattern (to be passed to the function \code{grep})}
  \item{skip}{number of entries to skip}
  \item{x}{a FASTA sequence object}
  \item{...}{optional arguments to be forwarded to the function
    \code{print} or to the function \code{grep}}
}
\details{
  \code{countskip.FASTA.entries} skips the remaining FASTA entries
  currently remaining in the connection and return the count.
  \code{grep.FASTA.entry} returns the next FASTA entry in the connection
  that matches a given regular expression.
  \code{print.FASTA} prints a FASTA object.
  \code{read.FASTA.entry} reads the next FASTA entry in the connection.
  \code{read.n.FASTA.entries} reads the \code{n} next FASTA entries and
  returns a \code{list} of FASTA objects.
  \code{read.n.FASTA.entries.split} reads the \code{n} next FASTA
  entries and returns a list of two elements: headers and sequences.
  \code{read.n.FASTA.headers} reads the \code{n} next FASTA headers.
  \code{read.n.FASTA.sequences} reads the \code{n} next FASTA sequences.
  \code{skip.FASTA.entry} skips a given number of FASTA entries.
  \code{write.FASTA} write a FASTA object into a connection.
%  ~~ If necessary, more details than the __description__  above ~~
}
\value{
 The value returned depends on the function. See above.
}
\author{ Laurent Gautier }
\examples{
filename <- system.file("exampleData", "sample.fasta",
                        package="altcdfenvs")
con <- file(filename, open="r")

fasta.seq <- grep.FASTA.entry("NM_001544\\\.2", con)
close(con)


print(fasta.seq)
}
\keyword{ manip }
\keyword{ IO }
\keyword{ connection }

\name{geneNames.CdfEnvAffy}
%\alias{geneNames.AltAffyBatch}
\alias{geneNames.CdfEnvAffy}
\title{ get the names of the known probe sets }
\description{
  get the names of the probe sets known to the CdfEnv
}
\usage{
%geneNames.AltAffyBatch(object)
geneNames.CdfEnvAffy(object)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{object}{  \code{CdfEnvAffy-class}} %\code{AltAffyBatch-class} or
}
\value{
  a vector of mode \code{character}
}
\keyword{ manip}

\name{indexProbes.CdfEnvAffy}
\alias{indexProbes.CdfEnvAffy}
%\alias{indexProbes.AltAffyBatch}
\title{ indexes for probes }
\description{
  A function to get the index for probes
}
\usage{
indexProbes.CdfEnvAffy(object, which, probeSetNames = NULL)
%indexProbes.AltAffyBatch(object, which, probeSetNames = NULL)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{object}{ \code{CdfEnvAffy}}% or \code{AltAffyBatch}}
  \item{which}{ which kind of probe are of interest (see details). }
  \item{probeSetNames}{ names of the probe sets of interest. If
    \code{NULL}, all the probe sets are considered. }
}
\details{
  The parameter \code{which} let one specify which category of probes
  are of interest. In the case of Affymetrix chips, probes can be \code{"pm"}
  probes or \code{"mm"} probes. It the parameter is set to \code{c("pm",
    "mm")}, both are returned. Should other categories be defined, they
  can be handled as well.
  
%  One can note that the method \code{indexProbes} defined for the
%  class \code{AltAffyBatch} in only a convenience
%  accessor function (since logically the indexes are computed from the cdfenv
%  information).
}
\value{
A \code{list} of indexes.
}
\seealso{\code{\link{CdfEnvAffy-class}}, \code{\link[affy]{AffyBatch-class} }}
\keyword{ manip }

\name{index2xy}
\alias{index2xy}
\alias{index2xy.CdfEnvAffy}
%\alias{index2xy.AltAffyBatch}
\alias{xy2index}
\alias{xy2index.CdfEnvAffy}
%\alias{xy2index.AltAffyBatch}
\title{ Functions to shuttle from indexes to XY coordinates }
\description{
  Functions to shuttle from indexes to XY coordinates.
}
\usage{
index2xy(object, ...)
xy2index(object, ...)
index2xy.CdfEnvAffy(object, i)
%index2xy.AltAffyBatch(object, i)
xy2index.CdfEnvAffy(object, x, y)
%xy2index.AltAffyBatch(object, x, y)
}
\arguments{
  \item{object}{An object of class \code{CdfEnvAffy}.}
  \item{i}{A vector of indexes.}
  \item{x, y}{Vectors of X and Y coordinates.}
  \item{\dots}{Optional parameters (not used).}
}
\value{
  A vector of integers (for \code{xy2index} methods), or a matrix of two
  columns (for \code{index2xy} methods).
}
\seealso{ \code{\link{CdfEnvAffy-class}}}
\examples{
## To be done...
}
\keyword{ manip }

\name{removeIndex}
\alias{removeIndex}
\title{ A function to remove probes in an environment }
\description{
  A function to remove probes in an environment, given their index.
}
\usage{
removeIndex(x, i, simplify = TRUE, verbose = FALSE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{x}{ An instance of \code{CdfEnvAffy-class} }
  \item{i}{ A vector of indexes (integers !). }
  \item{simplify}{ Simply the resulting \code{CdfEnvAffy} (see details). }
  \item{verbose}{ verbose output or not. }
}
\details{
  The probes to be removed are set to \code{NA} in the CdfEnvAffy.
  When \code{simplify} is set to \code{TRUE} the probe sets are
  simplified whenever possible. For example, if both pm and mm for the
  same probe pair are set to \code{NA}, then the probe pair is removed
  from the probe set. 
}
\value{
  An instance of \code{CdfEnvAffy-class} is returned.
}
\author{ Laurent Gautier }
\seealso{ \code{\link{CdfEnvAffy-class}} }
\examples{

## use plasmodiumanopheles chip as an example
if (require(plasmodiumanophelescdf)) {

  ## wrap in a (convenient) CdfEnvAffy object
  planocdf <- wrapCdfEnvAffy(plasmodiumanophelescdf, 712, 712, "plasmodiumanophelescdf")
  print(planocdf)

  ## ask for the probe indexed '10759' to be removed
  ## (note: if one wishes to remove from X/Y coordinates,
  ## the function xy2index can be of help).
  planocdfCustom <- removeIndex(planocdf, as.integer(10759))

  ## let see what happened (we made this example knowing in which
  ## probe set the probe indexed '10759' is found).
  indexProbes(planocdf, "pm", "200000_s_at")
  indexProbes(planocdfCustom, "pm", "200000_s_at")
  ## The 'second' pm probe (indexed '10579') in the probe set is now set
  ## to NA.
}

}
\keyword{ manip }

\name{toHypergraph}
\alias{toHypergraph}

\title{Transform to an hypergraph}
\description{
  Transform to an hypergraph
}
\usage{
toHypergraph(object, ...)
}
\arguments{
  \item{object}{Object derived from class \code{AffyProbesMatch}.}
  \item{...}{Unused.}
}
\value{
  An \code{\link[hypergraph]{Hypergraph-class}} object. 
}
\keyword{manip}

\name{appendCdfEnvAffy}
\alias{appendCdfEnvAffy}
\title{ append probe sets to a CdfEnvAffy}
\description{
  append probe sets to a CdfEnvAffy
}
\usage{
appendCdfEnvAffy(acdfenv, id, i, nocopy = TRUE)
}
\arguments{
  \item{acdfenv}{ instance of class \code{CdfEnvAffy}}
  \item{id}{ identifier for the probe set to add }
  \item{i}{ a \code{matrix} of indexes (see details)}
  \item{nocopy}{whether to make a copy of the environment or not (see details)}
}
\details{
  The \code{matrix} \code{i} must have one column per probe type. For
  typical Affymetrix chip types, there are two probe types: \code{"pm"}
  and \code{"mm"}.

  \code{nocopy} set to \code{TRUE} means that the environment is added
  the probe set 'in-situ' (this can boost execution speed if you add a
  lot of probe sets).
}
\value{
  An \code{CdfEnvAffy} is returned
}
\examples{
data(cdfenvEx)

## pm and mm probe set
m <- matrix(1:10, ncol = 2)
colnames(m) <- c("pm", "mm")

appendCdfEnvAffy(cdfenvEx, "blabla", m)

indexProbes(cdfenvEx, c("pm", "mm"), "blabla")

## pm only probe set
m <- matrix(6:9, ncol = 1)
colnames(m) <- c("pm")
appendCdfEnvAffy(cdfenvEx, "blabla2", m)
## note that the unspecified "mm" were set to NA
indexProbes(cdfenvEx, c("pm", "mm"), "blabla2")


}
\keyword{ manip }

\name{getxy.probeseq}
\alias{getxy.probeseq}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ A function to get the XY coordinates from a probes sequences
  data frame}
\description{
 A function to get the XY coordinates from a probes sequences \code{data.frame}
}
\usage{
getxy.probeseq(ppset.id = NULL, probeseq = NULL, i.row = NULL,
xy.offset = NULL, x.colname = "x", y.colname = "y")
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{ppset.id}{ The probe sets of interest (a vector of mode \code{character}. }
  \item{probeseq}{ The probe sequence \code{data.frame} (see details). }
  \item{i.row}{ Row indexes in the \code{data.frame} (see details). }
  \item{xy.offset}{ Offset for the xy coordinates. if \code{NULL}, uses
    the default offset stored as an option for the affy package. }
  \item{x.colname, y.colname}{ The probe sequence packages have seen the
    names for the columns in their \code{data.frame}. This parameters
    exists to let us follow these changes.}
}
\details{
  The \code{data.frame} passed as argument \code{probeseq} is expected
  to have (at least) the following columns: \code{Probe.X},
  \code{Probe.Y} and \code{Probe.Set.Name}. When the argument
  \code{ppset.id} is not null, the probe sets
}
\value{
A \code{matrix} of two columns. The first column contains x coordinates,
while the second column contains y coordinates.
}
\author{ Laurent }

\section{Warning }{
  The parameter \code{xy.offset.one} is here for historical
  reasons. This should not be touched, the option in the affy
  package should be modified if one wishes to modify this.
  
  This function should not be confused with the methods \code{index2xy}
  and similar. Here the the XY coordinate come from a \code{data.frame}
  that stores information about an arbitrary number probes on the
  chip. (See the `probe sequence' data packages on Bioconductor, and the
  package \code{Biostrings}).
  
  The methods \code{index2xy} are meant to interact with instances of
  class \code{AffyBatch}.
}

%\seealso{ ~~objects to See Also as \code{\link{~~fun~~}}, ~~~ }
\examples{
##---- Should be DIRECTLY executable !! ----
}
\keyword{ manip }

\name{AffyProbesMatch-class}
\docType{class}
\alias{AffyProbesMatch-class}
\alias{combine,AffyProbesMatch,AffyProbesMatch-method}
\alias{show,AffyProbesMatch-method}
\alias{toHypergraph,AffyProbesMatch-method}
\title{Class "AffyProbesMatch"}
\description{
Store the results of a call to \code{matchAffyProbes}.
}
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("AffyProbesMatch", ...)}.

An object will store the result of
matching probe sequences against target sequences.
}
\section{Slots}{
  \describe{
    \item{\code{pm}:}{Object of class \code{"list"}:
      each element is vector of index values}
    \item{\code{mm}:}{Object of class \code{"list"}:
      each element is vector of index values}
    \item{\code{labels}:}{Object of class \code{"character"}}
    \item{\code{chip_type}:}{Object of class \code{"character"}
      and of length 1.}
    \item{\code{probes}:}{Object of class \code{"ANY"}:
      the \code{probetable} object used to perform the matches.
    }
  }
}
\section{Methods}{
  \describe{
    \item{combine}{\code{signature(x = "AffyProbesMatch", y =
	"AffyProbesMatch")}: combine two instances. This is can
      be useful when splitting the list of target sequences to
      parallelized the job.}
    \item{show}{\code{signature(x = "AffyProbesMatch")}:Show the
      instance.}
    \item{toHypergraph}{\code{signature(object = "AffyProbesMatch")}:
    build an \code{\link[hypergraph]{Hypergraph}} from the matches.}
  }
}
%\references{ ~put references to the literature/web site here ~ }
%\author{ ~~who you are~~ }
%\note{ ~~further notes~~ }
%
% ~Make other sections like Warning with \section{Warning }{....} ~
%
%\seealso{
%	~~objects to See Also as \code{\link{~~fun~~}}, ~~~
%	or \code{\linkS4class{CLASSNAME}} for links to other classes
%}
\examples{
showClass("AffyProbesMatch")
}
\keyword{classes}

\name{cdfenvs}
\alias{wrapCdfEnvAffy}
\alias{getCdfEnvAffy}
\alias{buildCdfEnv.matchprobes}
\alias{CdfEnv}
\title{ functions related to cdfenvs }
\description{
  A set of functions to handle cdfenvs
}
\usage{
wrapCdfEnvAffy(cdfenv, nrow.chip, ncol.chip, chiptype, check = TRUE,
               verbose = FALSE)
getCdfEnvAffy(abatch)
buildCdfEnv.matchprobes(matches, ids, probes.pack, abatch=NULL,
                        nrow.chip=NULL, ncol.chip=NULL, chiptype=NULL,
                        mm=NA, simplify = TRUE,
                        x.colname = "x", y.colname = "y", verbose=FALSE)
}
\arguments{
  \item{abatch}{an \code{AffyBatch}}
  \item{cdfenv}{A cdfenv environment}
  \item{check}{perform consistency check or not}
  \item{chiptype}{A name for the chip type}
  \item{ids}{a vector of probe set identifiers for the matches}
  \item{matches}{a list as returned by the function
    \code{combineAffyBatch}}
  \item{mm}{The value to store for MMs}
  \item{ncol.chip}{The number of columns for the chip type}
  \item{nrow.chip}{The number of rows for the chip type}
  \item{probes.pack}{The name of the probe package}
  \item{simplify}{Simplify the environment created by removing the ids
    without any matching probe}
  \item{x.colname, y.colname}{see the \code{getxy.probeseq}}
  \item{verbose}{verbosity (\code{TRUE} or \code{FALSE})}
}
\value{
  An instance of class \code{CdfEnvAffy}.
}
\examples{
## See the main vignette
}
\keyword{manip}

\name{matchAffyProbes}
\alias{matchAffyProbes}
\alias{mmProbes}
\title{ Match the probes on an Affymetrix array }
\description{
  Match the individual probes on an Affymetrix array to
  arbitrary targets.
}
\usage{
mmProbes(probes)

matchAffyProbes(probes, targets, chip_type,
                matchmm = TRUE,
                selectMatches = function(x) which(elementNROWS(x) > 0),
                ...)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{probes}{ a \code{probetable} object }
  \item{targets}{ a vector of references }
  \item{chip_type}{a name for the chip type.}
  \item{matchmm}{whether to match MM probes or not}
  \item{selectMatches}{a function to select matches (see Details).}
  \item{...}{further arguments to be passed to \code{matchPDict}.}
}
\details{
  The matching is performed by the function
  \code{\link[Biostrings:matchPDict-exact]{matchPDict}}. The man page
  for that function will indicate what are the options it accepts.
  
  In the case where a large number targets are given, like when
  each target represents a possible mRNA, is it expected to have a
  largely sparse incidence matrix, that is a low number of probes
  matching every target. For that reason, only the index of matching
  probes are associated with each given target, with the function
  \code{selectMatches} giving the definition of what are
  matching probes. The default function just count anything matching,
  but the user can specify a more stringent definition if wanted.
}
\value{
  \code{mmProbes} returns a vector of MM probe sequences.
  
  \code{matchAffyProbes} returns an instance of \code{AffyProbesMatch-class}.
}
\author{ Laurent Gautier }

\seealso{ \code{\link[Biostrings:matchPDict-exact]{matchPDict}} for
  details on how the matching is performed, \code{\link{AffyProbesMatch-class}}
    and \code{\link{buildCdfEnv.biostrings}}}
\examples{

library(hgu133aprobe)

filename <- system.file("exampleData", "sample.fasta",
                        package="altcdfenvs")

fasta.seq <- readDNAStringSet(filename)

targets <- as.character(fasta.seq)
names(targets) <- sub("^>.+\\\\|(NM[^ \\\\|]+|Hs[^ \\\\|]+)\\\\| ? .+$", "",
                      names(targets))

m <- matchAffyProbes(hgu133aprobe,
                     targets,
                     "HG-U133A")


}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ manip }

\name{CdfEnvAffy-class}
\docType{class}
\alias{CdfEnvAffy-class}
\alias{geneNames,CdfEnvAffy-method}
\alias{index2xy,CdfEnvAffy-method}
\alias{indexProbes,CdfEnvAffy,character-method}
\alias{plot,CdfEnvAffy,missing-method}
\alias{show,CdfEnvAffy-method}
\alias{xy2index,CdfEnvAffy-method}
\alias{coerce,CdfEnvAffy,environment-method}
\alias{coerce,CdfEnvAffy,Cdf-method}
\alias{toHypergraph,CdfEnvAffy-method}
\alias{[,CdfEnvAffy,character,missing,missing-method}

\title{Class "CdfEnvAffy"}
\description{A class to hold the information necessary to handle the
  grouping of probes in set of probes, and to find XY coordinates
 of probes on a chip}
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("CdfEnvAffy", ...)}.
Typically, there is an instance of the class for each type of chip
(e.g. Hu6800, HG-U95A, etc\ldots).
}
\section{Slots}{
  \describe{
    \item{\code{envir}:}{Object of class \code{"environment"}. It has to
      be thought of as a hashtable: the keys are probe set identifiers,
      or gene names, and the values are indexes.}
    \item{\code{envName}:}{Object of class \code{"character"}. A name
      for the environment.}
    \item{\code{index2xy}:}{Object of class \code{"function"}. The
      function used to resolve index into xy coordinates. Unless you are
    an advanced user, you probably want to ignore this (and rely on the
    default provided with the package).}
    \item{\code{xy2index}:}{Object of class \code{"function"}. The
      function used to resolve xy coordinates into index. Unless you are
    an advanced user, you probably want to ignore this (and rely on the
    default provided with the package).}
    \item{\code{nrow}:}{Object of class \code{"integer"}. The number of
      rows of probes for the chip type.}
    \item{\code{ncol}:}{Object of class \code{"integer"}. The number of
      columns of probes for the chip type.}
    \item{\code{probeTypes}:}{Object of class \code{"character"}. The
      different types of probes stored for each probe set. In the case
      of Affymetrix chips, the probes are typically perfect match
      (pm) probes or mismatch probes (mm).}
    \item{\code{chipType}:}{Object of class \code{"character"}. The name
      of the chip type the instance is associated with. This is useful
      when one starts to create alternative mappings of the probes on a
      chip (see associated vignette).}
  }
}
\section{Methods}{
  \describe{
    \item{[}{\code{signature(object = "CdfEnvAffy",
	i = "character", j = "missing", drop = "boolean")}: subset a cdf, that
      is return a new cdf containing only a subset of the probe
      sets. The subset of probe sets to take is identified as a vector
      of identifiers (mode "character").}
    \item{coerce}{\code{signature(object = "CdfEnvAffy", "environment")}: coerce an
      instance of the class to an \code{environment}.}
    \item{coerce}{\code{signature(object = "CdfEnvAffy", "Cdf")}: coerce an
      instance of the class to a \code{Cdf}.}
    \item{geneNames}{\code{signature(object="CdfEnvAffy")}: Return the
    names of the known probe sets (of course, it depends on the associated CDF).}
    \item{index2xy}{\code{signature(object = "CdfEnvAffy", i="integer")}: convert
      index values into XY coordinates.}
    \item{indexProbes}{\code{signature(object = "CdfEnvAffy", which =
	"character", probeSetNames = NULL)}: obtain the indexes for the probes associated wit
      the probe set name \code{probeSetNames}. When \code{probeSetNames}
      is set to \code{NULL} (default), the indexes are returned for the
      probe sets defined on the chip. See \code{indexProbes.CdfEnvAffy}}
    \item{plot}{\code{signature(x = "CdfEnvAffy", y = "missing")}: Plot
      the chip. It mainly sets coordinates for further plotting (see
      examples). See \code{plot.CdfEnvAffy}}
    \item{show}{\code{signature(object = "CdfEnvAffy")}: Print method.}
    \item{xy2index}{\code{signature(object = "CdfEnvAffy", x="integer", y="integer")}: convert XY
      coordinates into index values.}
    \item{toHypergraph}{\code{signature(object = "CdfEnvAffy")}: convert XY
      coordinates into index values.}
  }
}
%\references{ ~put references to the literature/web site here ~ }
\author{Laurent Gautier}
%\note{ ~~further notes~~ }

% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
  \code{\link{indexProbes.CdfEnvAffy}}, \code{\link{plot.CdfEnvAffy}}
  %  ~~objects to See Also as \code{\link{~~fun~~}}, ~~~
%  or \code{\link{CLASSNAME-class}} for links to other classes
}
\examples{
## build an instance
library(hgu95acdf)
cdfenv.hgu95a <- wrapCdfEnvAffy(hgu95acdf, 640, 640, "HG-U95A")

show(cdfenv.hgu95a)

## find the indexes for a probe set (pm only)
ip <- indexProbes(cdfenv.hgu95a, "pm", "1000_at")[[1]]
## get the XY coordinates for the probe set
xy <- index2xy(cdfenv.hgu95a, ip)

## plot the chip
plot(cdfenv.hgu95a)

## plot the coordinates
plotLocation(xy)

## subset the environment

cdfenv.hgu95a.mini <- cdfenv.hgu95a["1000_at"]

}
\keyword{classes}

\name{buildCdfEnv.biostrings}
\alias{buildCdfEnv.biostrings}
\title{ Build CDF environments}
\description{
  Build CDF environment from Biostrings matchPDict results
}
\usage{
buildCdfEnv.biostrings(apm, abatch = NULL,
                       nrow.chip = NULL, ncol.chip = NULL,
                       simplify = TRUE,
                       x.colname = "x", y.colname = "y",
                       verbose = FALSE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{apm}{ \code{AffyProbesMatch}}
  \item{abatch}{ \code{AffyBatch} }
  \item{nrow.chip}{number of rows for the chip type (see details)}
  \item{ncol.chip}{number of columns for the chip type (see details)}
  \item{simplify}{simplify the environment built (removing
  target names when there is no matching probe)}
  \item{x.colname}{ column name }
  \item{y.colname}{ column name}
  \item{verbose}{ verbose \code{TRUE}/\code{FALSE}}
}
\details{
  %  ~~ If necessary, more details than the description above ~~
  Whenever an \code{abatch} is specified, \code{nrow.chip} and
  \code{ncol.chip} are not needed. Specifying the an \code{AffyBatch}
  in \code{abatch} is the easiest way to specify information about the
  geometry of a chip type.
}
\value{
  An instance of class \code{CdfEnvAffy}.
}
%\references{ ~put references to the literature/web site here ~ }
%\author{ ~~who you are~~ }
%\note{ ~~further notes~~ 
%
% ~Make other sections like Warning with \section{Warning }{....} ~
%}
%\seealso{ ~~objects to See Also as \code{\link{help}}, ~~~ }
%\examples{
%}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ manip }

\name{unique.CdfEnvAffy}
\alias{unique.CdfEnvAffy}
\title{ Remove duplicated elements from a CdfEnvAffy }
\description{
  Remove duplicated elements from a CdfEnvAffy
}
\usage{
\method{unique}{CdfEnvAffy}(x, incomparables = FALSE, simplify = TRUE, verbose = FALSE, ...)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{x}{ An instance of \code{CdfEnvAffy-class} }
  \item{incomparables}{ (not yet implemented) }
  \item{simplify}{ simplify the result }
  \item{verbose}{ verbose or not }
  \item{\dots}{ (here for compatibility with the generic \code{unique}) }
}
\details{
  The parameter \code{simplify} has the same function as the one with
  the same name in \code{countduplicated}.
}
\value{
  An instance of \code{CdfEnvAffy-class} in which probes used several
  times are removed.
}
\author{ Laurent }
\section{Warning }{The function differs slightly from the generic
  \code{unique}. Here the elements found in several place a merely removed.}

\seealso{\code{\link{countduplicated}} }
\examples{
##not yet here...
}
\keyword{ manip }

\name{cdfenvEx}
\alias{cdfenvEx}
\docType{data}
\title{ CdfEnvAffy}
\description{
An example of \code{CdfEnvAffy}
}
\usage{data(cdfenvEx)}
\format{
  The format is:
Formal class 'CdfEnvAffy' [package "altcdfenvs"] with 8 slots
  ..@ index2xy  :function (object, i)  
  ..@ xy2index  :function (object, x, y)  
  ..@ envir     :length 2 <environment>
  ..@ envName   : chr "ZG-DU33"
  ..@ nrow      : int 100
  ..@ ncol      : int 100
  ..@ probeTypes: chr [1:2] "pm" "mm"
  ..@ chipType  : chr "ZG-DU33"
}
\examples{
data(cdfenvEx)

print(cdfenvEx)
}
\keyword{datasets}

\name{validAffyBatch}
\alias{validAffyBatch}
\alias{validCdfEnvAffy}
\alias{printValidCdfEnvAffy}
\title{Check validity of a CdfEnvAffy.}
\description{
  Tries to see if a CdfEnvAffy, or a pair of AffyBatch / CdfEnvAffy is valid.
}
\usage{
validAffyBatch(abatch, cdfenv)
validCdfEnvAffy(cdfenv, verbose=TRUE)
printValidCdfEnvAffy(x)
}
\arguments{
  \item{abatch}{ instance of \code{\link[affy]{AffyBatch-class}} }
  \item{cdfenv}{ instance of \code{\link{CdfEnvAffy-class}} }
  \item{verbose}{ verbose or not}
  \item{x}{object returned by \code{validCdfEnvAffy}}
}
\details{
  The function \code{validAffyBatch} calls in turn
  \code{validCdfEnvAffy}.
}
\seealso{ \code{\link[affy]{AffyBatch-class}}, \code{\link{CdfEnvAffy-class}} }
\examples{
## To be done...
}
\keyword{ manip }

\name{copyCdfEnvAffy}
\alias{copyCdfEnvAffy}
\title{ make a copy of a CdfEnvAffy }
\description{
  make a copy of a CdfEnvAffy
}
\usage{
copyCdfEnvAffy(acdfenv)
}
\arguments{
  \item{acdfenv}{ instance of class \code{CdfEnvAffy} }
}
\details{
  Make a copy can be needed since a \code{CdfEnvAffy} contains an \code{environment}
}
\value{
  A \code{CdfEnvAffy}
}
\seealso{\code{\link{CdfEnvAffy-class}}, \code{\link[Biobase]{copyEnv}}}
\keyword{ manip }% at least one, from doc/KEYWORDS

\name{countduplicated}
\alias{countduplicated}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Count the number of times probes are used }
\description{
  This function counts the number of times the probes in a CdfEnvAffy
  are found in this object.
}
\usage{
countduplicated(x, incomparables = FALSE, verbose = FALSE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{x}{An instance of \code{CdfEnvAffy-class} }
  \item{incomparables}{ (not implemented yet, keep away) }
  \item{verbose}{ verbose or not }
}

\value{
  An \code{environment} is returned. Each element in this
  \code{environment} has the same identifier than its corresponding
  probe set in the \code{CdfEnvAffy-class} and contains the number of
  times a probe is in use in the environment (instead of an index number
  in the \code{CdfEnvAffy-class}).
}
\author{ Laurent }
\seealso{ \code{\link{CdfEnvAffy-class}}}

\keyword{ manip }
